# FoundationClasses
TKMath
math

# math_Uzawa Class Reference

This class implements a system resolution C*X = B with
an approach solution X0. There are no conditions on the
number of equations. The algorithm used is the Uzawa
algorithm. It is possible to have equal or inequal (<)
equations to solve. The resolution is done with a
minimization of Norm(X-X0).
If there are only equal equations, the resolution is directly
done and is similar to Gauss resolution with an optimisation
because the matrix is a symmetric matrix.
(The resolution is done with Crout algorithm)
.

`#include <math_Uzawa.hxx>`

## Public Member Functions

void * | operator new (size_t, void *anAddress)
void * | operator new (size_t size)
void | operator delete (void *anAddress)
Standard_EXPORT | math_Uzawa (const math_Matrix &Cont, const math_Vector &Secont, const math_Vector &StartingPoint, const Standard_Real EpsLix=1.0e-06, const Standard_Real EpsLic=1.0e-06, const Standard_Integer NbIterations=500)

Given an input matrix Cont, two input vectors Secont
and StartingPoint, it solves Cont*X = Secont (only
= equations) with a minimization of Norme(X-X0).
The maximun iterations number allowed is fixed to
NbIterations.
The tolerance EpsLic is fixed for the dual variable
convergence. The tolerance EpsLix is used for the
convergence of X.
Exception ConstuctionError is raised if the line number
of Cont is different from the length of Secont.
.

Standard_EXPORT | math_Uzawa (const math_Matrix &Cont, const math_Vector &Secont, const math_Vector &StartingPoint, const Standard_Integer Nci, const Standard_Integer Nce, const Standard_Real EpsLix=1.0e-06, const Standard_Real EpsLic=1.0e-06, const Standard_Integer NbIterations=500)

Given an input matrix Cont, two input vectors Secont
and StartingPoint, it solves Cont*X = Secont (the Nce
first equations are equal equations and the Nci last
equations are inequalities <) with a minimization
of Norme(X-X0).
The maximun iterations number allowed is fixed to
NbIterations.
The tolerance EpsLic is fixed for the dual variable
convergence. The tolerance EpsLix is used for the
convergence of X.
There are no conditions on Nce and Nci.
Exception ConstuctionError is raised if the line number
of Cont is different from the length of Secont and from
Nce + Nci.
.

Standard_Boolean | IsDone () const
| Returns true if the computations are successful, otherwise returns false. .
const math_Vector & | Value () const
| Returns the vector solution of the system above. An exception is raised if NotDone. .
const math_Vector & | InitialError () const
| Returns the initial error Cont*StartingPoint-Secont. An exception is raised if NotDone. .
Standard_EXPORT void | Duale (math_Vector &V) const
| returns the duale variables V of the systeme.
const math_Vector & | Error () const
| Returns the difference between X solution and the StartingPoint. An exception is raised if NotDone. .
Standard_Integer | NbIterations () const
| returns the number of iterations really done. An exception is raised if NotDone.
const math_Matrix & | InverseCont () const
| returns the inverse matrix of (C * Transposed(C)). This result is needed for the computation of the gradient when approximating a curve.
Standard_EXPORT void | Dump (Standard_OStream &o) const
| Prints information on the current state of the object. .

## Protected Member Functions

Standard_EXPORT void | Perform (const math_Matrix &Cont, const math_Vector &Secont, const math_Vector &StartingPoint, const Standard_Integer Nci, const Standard_Integer Nce, const Standard_Real EpsLix=1.0e-06, const Standard_Real EpsLic=1.0e-06, const Standard_Integer NbIterations=500)
| Is used internally by the two constructors above. .

## Private Attributes

math_Vector | Resul
math_Vector | Erruza
math_Vector | Errinit
math_Vector | Vardua
math_Matrix | CTCinv
Standard_Integer | NbIter
Standard_Boolean | Done

## Constructor & Destructor Documentation

Standard_EXPORT math_Uzawa::math_Uzawa | ( | const math_Matrix & | Cont,
|  | const math_Vector & | Secont,
|  | const math_Vector & | StartingPoint,
|  | const Standard_Real | EpsLix = `1.0e-06`,
|  | const Standard_Real | EpsLic = `1.0e-06`,
|  | const Standard_Integer | NbIterations = `500`
| ) |

Standard_EXPORT math_Uzawa::math_Uzawa | ( | const math_Matrix & | Cont,
|  | const math_Vector & | Secont,
|  | const math_Vector & | StartingPoint,
|  | const Standard_Integer | Nci,
|  | const Standard_Integer | Nce,
|  | const Standard_Real | EpsLix = `1.0e-06`,
|  | const Standard_Real | EpsLic = `1.0e-06`,
|  | const Standard_Integer | NbIterations = `500`
| ) |

## Member Function Documentation

Standard_EXPORT void math_Uzawa::Duale | ( | math_Vector & | V | ) | const

Standard_EXPORT void math_Uzawa::Dump | ( | Standard_OStream & | o | ) | const

const math_Vector & math_Uzawa::Error | ( |  | ) | const`[inline]`

const math_Vector & math_Uzawa::InitialError | ( |  | ) | const`[inline]`

const math_Matrix & math_Uzawa::InverseCont | ( |  | ) | const`[inline]`

Standard_Boolean math_Uzawa::IsDone | ( |  | ) | const`[inline]`

Standard_Integer math_Uzawa::NbIterations | ( |  | ) | const`[inline]`

void math_Uzawa::operator delete | ( | void * | anAddress | ) | `[inline]`

void* math_Uzawa::operator new | ( | size_t | size | ) | `[inline]`

void* math_Uzawa::operator new | ( | size_t | ,
|  | void * | anAddress
| ) | `[inline]`

Standard_EXPORT void math_Uzawa::Perform | ( | const math_Matrix & | Cont,
|  | const math_Vector & | Secont,
|  | const math_Vector & | StartingPoint,
|  | const Standard_Integer | Nci,
|  | const Standard_Integer | Nce,
|  | const Standard_Real | EpsLix = `1.0e-06`,
|  | const Standard_Real | EpsLic = `1.0e-06`,
|  | const Standard_Integer | NbIterations = `500`
| ) | `[protected]`

const math_Vector & math_Uzawa::Value | ( |  | ) | const`[inline]`

## Field Documentation

math_Matrix math_Uzawa::CTCinv `[private]`

Standard_Boolean math_Uzawa::Done `[private]`

math_Vector math_Uzawa::Errinit `[private]`

math_Vector math_Uzawa::Erruza `[private]`

Standard_Integer math_Uzawa::NbIter `[private]`

math_Vector math_Uzawa::Resul `[private]`

math_Vector math_Uzawa::Vardua `[private]`

The documentation for this class was generated from the following files:

- math_Uzawa.hxx
- math_Uzawa.lxx